/* Problem URL: https://codeforces.com/contest/2107/problem/C */

#include <bits/stdc++.h>

using namespace std;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

ll inf = 1e17;

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        int n;
        ll k;
        cin >> n >> k;

        string a;
        cin >> a;

        vl fds(n);
        rep(i, n) {
            cin >> fds[i];
            if (a[i] == '0') {
                fds[i] = -inf;
            }
        }

        if (n == 1) {
            if (a[0] == '0') {
                fds[0] = k;
            }

            if (fds[0] == k) {
                cout << "Yes\n" << k << "\n";
                continue;
            }

            cout << "No\n";
            continue;
        }

        ll total = 0;
        ll maximus = 0;
        rep(i, n) {
            total += fds[i];
            rmax(total, 0LL);
            rmax(maximus, total);
        }

        if (maximus > k) {
            cout << "No\n";
            continue;
        }

        if (maximus == k) {
            cout << "Yes\n";
            cout << fds;
            continue;
        }

        vl pref(n);
        vl suf(n);

        pref[0] = fds[0];
        suf.back() = fds.back();
        nrep(i, 1, n) {
            pref[i] = max(fds[i], fds[i] + pref[i - 1]);
            suf[n - i - 1] = max(fds[n - i - 1], fds[n - i - 1] + suf[n - i]);
        }


        if (suf[1] <= k && a[0] == '0') {
            cout << "Yes\n";
            fds[0] = k - max(suf[1], 0LL);
            cout << fds;
            continue;
        }

        if (pref[n - 2] <= k && a[n - 1] == '0') {
            cout << "Yes\n";
            fds[n - 1] = k - max(pref[n - 2], 0LL);
            cout << fds;
            continue;
        }

        bool pos = false;
        nrep(i, 1, n - 1) {
            if (a[i] == '0') {
                pos = true;
                fds[i] = k - (max(pref[i - 1], 0LL) + max(suf[i + 1], 0LL));
                break;
            }
        }

        if (pos) {
            cout << "Yes\n";
            cout << fds;

            continue;
        }

        cout << "No\n";
    }
}
